;
; $Log:   C:/shell/vcs/ctlbrk.asv  $
; 
;    Rev 3.4   01 Oct 1986  9:25:34   kent
; Initial revision.
;
ifdef AZTEC86
	include lmacros.h
endif

ifdef MSC
_TEXT	segment byte public 'CODE'
_DATA segment word public 'DATA'
endif
ifdef AZTEC86
dataseg	segment	word public 'DATA'
endif

ifdef AZTEC86
	extrn	_PSP_:word
endif
ifdef MSC
	extrn __psp:word
endif
	localstk	dw	20	dup(?)
	stktop	label	word
	savess	dw ?
	savesp	dw ?

ifdef MSC
_DATA	ends
assume cs:_TEXT,ds:_DATA
endif
ifdef AZTEC86
dataseg	ends
	assume	cs:code,ds:dataseg
endif

ourds	dw	0

;
ifdef AZTEC86
	procdef	ctl_brk_setup
endif
ifdef MSC
	public _ctl_brk_setup
_ctl_brk_setup	proc	near
	push	bp
	mov	bp,sp
endif
	mov	cs:ourds,ds
	push	ds
	mov	ax,3523H	;get cntl-break (cntl-c) handler
	int	21H
	push	bx		;offset  of handler
	push	es		;segment of handler
	mov	dx,offset brk_handler
	mov	ax,cs
	mov	ds,ax
	mov	ax,2523H	;set new cntl-break handler
	int	21H
	pop	dx		;restore into a 'long return'
	pop	ax
	pop	ds
ifdef AZTEC86
	pret
	pend	ctl_brk_setup
endif
ifdef MSC
	pop	bp
	ret
_ctl_brk_setup	endp
endif

ifdef AZTEC86
procdef	ctl_brk_restore	<<brkoff,word>,<brkseg,word>>
endif
ifdef MSC
	public _ctl_brk_restore
_ctl_brk_restore proc near
	push	bp
	mov	bp,sp
endif
	push	ds
ifdef AZTEC86
	mov	dx,brkoff
	mov	bx,brkseg
endif
ifdef MSC
	mov	dx,4[bp]
	mov	bx,6[bp]
endif
	mov	ds,bx
	mov	ax,2523H	;restore old cntl-break handler
	int	21H
	pop	ds
ifdef AZTEC86
	pret
	pend	ctl_brk_restore
endif
ifdef MSC
	pop	bp
	ret
_ctl_brk_restore	endp
endif	

brk_handler proc far
	;save ds and address our data segment
	push	ds
	mov	ds,cs:ourds
	;move to the local stack after saving dos stack
	push	ax
	mov	savess,ss
	mov	savesp,sp
	mov	ax,ds
	mov	ss,ax
	mov	sp,offset stktop
	;save registers
	push	bp
	push	bx
	push	cx
	push	dx
	push	si
	push	di
	push	es
	mov	ah,051H	;find the current psp
	int	21H
ifdef AZTEC86
	cmp	bx,_PSP_	;is it our program segment?
endif
ifdef MSC
	cmp	bx,__psp
endif
	je	noabort
	;set carry flag
	stc			; set carry flag
	jmp	short done
noabort:
	;clear carry flag
	clc
done:
	pop	es
	pop	di
	pop	si
	pop	dx
	pop	cx
	pop	bx
	pop	bp
	mov	ax,savess
	mov	ss,ax
	mov	sp,savesp
	pop	ax
	pop	ds
	jc	abortend
	iret
abortend:
	ret
brk_handler endp
ifdef AZTEC86
	finish
endif
ifdef MSC
_TEXT	ends
endif
	end
