/*
** $Log:   C:/SHELL/VCS/RM.C_V  $
**
**   Rev 3.6   06 Oct 1986 19:56:26   kent
**added standalone support for rm
**
**   Rev 3.5   01 Oct 1986 13:29:40   kent
**Put all globals into shell.h
**
**   Rev 3.4   01 Oct 1986  9:23:26   kent
**Initial revision.
*/
#ifndef MAIN
#include "shell.h"
int rm
#else
#include <stdio.h>
int main
#endif
(argc,argv)
	int argc;
	char *argv[];
{
	char ask = 0;

	if (argv[1][0] == '-' && toupper(argv[1][1]) == 'Q')
	{
		ask++;
		++argv; --argc;
	}
	while(--argc) 
	{
		++argv;
		if (strcmp(*argv,".")==0||strcmp(*argv,"..") == 0)
			continue;
		if (ask)
		{
			fprintf(stderr,"delete %s? (y or n) : ",*argv);
			if (toupper(bdos(0x1,0,0)) != 'Y')
			{
				write(2,"\r\n",2);
				continue;
			}
			write(2,"\r\n",2);
		}
		if (-1 == unlink(*(argv)))
		{
			perror("rm");
		}
	}
	return 0;
}


